// Socket.cpp: implementation of the Socket class.
//
//////////////////////////////////////////////////////////////////////

#include "Socket.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

bool Socket::initlib=false;

bool Socket::InitLibrary(void *pars)
{
	if(!initlib) {
		WSADATA data;
		WSAStartup(MAKEWORD(2,2),&data);
		initlib=true;
	}

	return initlib;
}

Socket::Socket():Resource((HANDLE)INVALID_SOCKET) {
	sin.sin_port=0;
}

Socket::Socket(SOCKET s):Resource((HANDLE)s) {
	sin.sin_port=0;
}

bool Socket::IsValid() {
	puts("Socket::IsValid()");
	return (SOCKET)h!=INVALID_SOCKET;
}

void Socket::SetInvalid() {
	h=(HANDLE)INVALID_SOCKET;
}

void Socket::Create(void *pars) {
	Resource::Create();

	if(pars==NULL) {
		sin.sin_family=AF_INET;
		h=(HANDLE)::socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	}
	else {
		int *par=(int *)pars;
		sin.sin_family=par[0];
		h=(HANDLE)::socket(par[0],par[1],par[2]);
	}
}

void Socket::DestroyResource() {
	puts("Socket::DestroyResource()");
	::closesocket((SOCKET)h);
}

void Socket::SetPort(int port) {
	sin.sin_port = htons(port);
	sin.sin_addr.s_addr = INADDR_ANY;

	::bind((SOCKET)h, (const struct sockaddr *)&sin, sizeof(sin));
}

Socket *Socket::Listen(int port,int dimlist) {
	if(sin.sin_port==0) {
		SetPort(port);
		::listen((SOCKET)h,dimlist);
	}
	
	int size_sin=sizeof(sin);
	return new Socket(::accept((SOCKET)h, (struct sockaddr *)&sin, &size_sin));
}

int Socket::Send(char *buf,int len,int flags) {
	return ::send((SOCKET)h,buf,len,flags);
}

int Socket::Receive(char *buf,int len,int flags) {
	return ::recv((SOCKET)h,buf,len,flags);
}
